unit fmain;
interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ToolWin, AppEvnts, ExtCtrls,
  ASCryptos, ASCryptoComp, ASGtMath, ASUtils;

type
  TForm1 = class(TForm)
    StatusBar1: TStatusBar;
    Pages1: TPageControl;
    tabSym: TTabSheet;
    GroupAlgo: TGroupBox;
    rbDES: TRadioButton;
    GroupSymKey: TGroupBox;
    EditSymKey: TEdit;
    btUpdSymKey: TButton;
    rbSymKeyHex: TRadioButton;
    rbSymKeyStr: TRadioButton;
    GroupSymData: TGroupBox;
    EditSym1: TEdit;
    EditSym2: TEdit;
    EditSym3: TEdit;
    btEncryptSym: TButton;
    btDecryptSym: TButton;
    rbSymDataHex: TRadioButton;
    rbSymDataStr: TRadioButton;
    TabSheet3: TTabSheet;
    MemoLog: TMemo;
    rbRC2: TRadioButton;
    rbRC4: TRadioButton;
    rbRC5: TRadioButton;
    rbBF: TRadioButton;
    rbCast: TRadioButton;
    rbIDEA: TRadioButton;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    AS_PrimeGenerator1: TAS_PrimeGenerator;
    AS_RandomGenerator1: TAS_RandomGenerator;
    btSaveSymKey: TButton;
    btGenSymKey: TButton;
    btLoadSymKey: TButton;
    LabelSymKey: TLabel;
    EditSymKeyLen: TEdit;
    Label5: TLabel;
    OpenDialog1: TOpenDialog;
    LabelSymKeyLim: TLabel;
    TabSheet2: TTabSheet;
    MDX1: TAS_DigestMDX;
    SHA1: TAS_DigestSHA1;
    GroupBox1: TGroupBox;
    rbMD2: TRadioButton;
    rbMD4: TRadioButton;
    rbMD5: TRadioButton;
    rbSHA1: TRadioButton;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    Label8: TLabel;
    EditDgData: TEdit;
    EditDigest: TEdit;
    btDigest: TButton;
    rbDgDataHex: TRadioButton;
    rbDgDataStr: TRadioButton;
    ToolBar1: TToolBar;
    tbEncryptSymFile: TToolButton;
    tbDecryptSymFile: TToolButton;
    ToolBar2: TToolBar;
    tbClearLog: TToolButton;
    ToolBar3: TToolBar;
    tbFileDigest: TToolButton;
    SHA1forRSA: TAS_DigestSHA1;
    Rip1: TAS_DigestRIPEMD160;
    rbRipEmd: TRadioButton;
    DES1: TAS_DESCryptography;
    RC21: TAS_RC2Cryptography;
    RC41: TAS_RC4Cryptography;
    RC51: TAS_RC5Cryptography;
    Blowfish1: TAS_BFCryptography;
    CAST1: TAS_CASTCryptography;
    IDEA1: TAS_IDEACryptography;
    RSA1: TAS_RSACryptography;
    TabSheet4: TTabSheet;
    ToolBar4: TToolBar;
    tbEncodeFile: TToolButton;
    tbDecodeFile: TToolButton;
    Base641: TAS_Base64Coding;
    GroupBox3: TGroupBox;
    rbBase64: TRadioButton;
    GroupBox4: TGroupBox;
    Label9: TLabel;
    Label10: TLabel;
    EditCodeSource: TEdit;
    EditEncoded: TEdit;
    btEncode: TButton;
    EditDecoded: TEdit;
    Label11: TLabel;
    btDecode: TButton;
    MDXforRSA: TAS_DigestMDX;
    tabRSA: TTabSheet;
    GroupRsaKey: TGroupBox;
    Label14: TLabel;
    LabelRsaKeyLim: TLabel;
    btUpdRsaKey: TButton;
    btSaveRsaKey: TButton;
    btGenRsaKey: TButton;
    btLoadRsaKey: TButton;
    EditRsaKeyLen: TEdit;
    GroupRsaData: TGroupBox;
    btEncryptRsa: TButton;
    btDecryptRsa: TButton;
    GroupScheme: TGroupBox;
    rbPkcs: TRadioButton;
    rbOaep: TRadioButton;
    ToolBar5: TToolBar;
    tbEncryptRsaFile: TToolButton;
    tbDecryptRsaFile: TToolButton;
    ToolButton3: TToolButton;
    tbSignFile: TToolButton;
    tbVerifyFile: TToolButton;
    ToolButton6: TToolButton;
    tbTestRsaKey: TToolButton;
    PanelIV: TPanel;
    EditIV: TEdit;
    LabelIV: TLabel;
    rbIVHex: TRadioButton;
    rbIVStr: TRadioButton;
    PanelShemeDigest: TPanel;
    cbRsaDigest: TComboBox;
    LabelRsaDigest: TLabel;
    PanelSymKeyOpt: TPanel;
    EditSymKeyOpt: TEdit;
    LabelSymKeyOpt: TLabel;
    Panel1: TPanel;
    Label6: TLabel;
    cbSmallPub: TComboBox;
    rbSafer: TRadioButton;
    Safer1: TAS_SaferCryptography;
    cbUseSaferSK: TCheckBox;
    rbSkipJack: TRadioButton;
    GroupCM: TGroupBox;
    rbECB: TRadioButton;
    rbCBC: TRadioButton;
    rbCFB: TRadioButton;
    rbOFB: TRadioButton;
    SkipJack1: TAS_SkipJackCryptography;
    PageControl1: TPageControl;
    TabRSAKeyN: TTabSheet;
    TabRSAKeyD: TTabSheet;
    TabRSAKeyE: TTabSheet;
    MemoRSAKeyN: TMemo;
    MemoRSAKeyD: TMemo;
    MemoRSAKeyE: TMemo;
    PageControl2: TPageControl;
    TabRsa1: TTabSheet;
    MemoRsa1: TMemo;
    TabSheet6: TTabSheet;
    MemoRsa2: TMemo;
    TabRsa3: TTabSheet;
    MemoRsa3: TMemo;
    rbRsaDataHex: TRadioButton;
    rbRsaDataStr: TRadioButton;
    RIPEMDforRSA: TAS_DigestRIPEMD160;
    TabOaepSeed: TTabSheet;
    MemoOaepSeed: TMemo;
    Button1: TButton;
    procedure btUpdSymKeyClick(Sender: TObject);
    procedure rbSymKeyHexClick(Sender: TObject);
    procedure rbSymKeyStrClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure rbDESClick(Sender: TObject);
    procedure btEncryptSymClick(Sender: TObject);
    procedure btDecryptSymClick(Sender: TObject);
    procedure rbSymDataHexClick(Sender: TObject);
    procedure rbSymDataStrClick(Sender: TObject);
    procedure tbClearLogClick(Sender: TObject);
    procedure CryptAfterDecrypt(Sender: TObject);
    procedure CryptAfterDecryptBlock(Sender: TObject; Block: Pointer; Offset, Size: Cardinal);
    procedure CryptAfterEncrypt(Sender: TObject);
    procedure CryptAfterEncryptBlock(Sender: TObject; Block: Pointer; Offset, Size: Cardinal);
    procedure CryptAfterGenKeys(Sender: TObject);
    procedure CryptAfterLoadKeys(Sender: TObject);
    procedure CryptAfterSaveKeys(Sender: TObject);
    procedure CryptBeforeDecrypt(Sender: TObject);
    procedure CryptBeforeDecryptBlock(Sender: TObject; Block: Pointer; Offset, Size: Cardinal);
    procedure CryptBeforeEncrypt(Sender: TObject);
    procedure CryptBeforeEncryptBlock(Sender: TObject; Block: Pointer; Offset, Size: Cardinal);
    procedure CryptBeforeGenKeys(Sender: TObject);
    procedure CryptBeforeLoadKeys(Sender: TObject);
    procedure CryptBeforeSaveKeys(Sender: TObject);
    procedure SymmChangeInitVector(Sender: TObject);
    procedure SymmChangeKey(Sender: TObject);
    procedure SymmPostValidateKey(Sender: TObject; Key: Pointer;
      KeyByteLen: Integer; var KeyValid: Boolean);
    procedure rbECBClick(Sender: TObject);
    procedure rbCBCClick(Sender: TObject);
    procedure rbCFBClick(Sender: TObject);
    procedure rbOFBClick(Sender: TObject);
    procedure rbRC2Click(Sender: TObject);
    procedure rbRC4Click(Sender: TObject);
    procedure rbRC5Click(Sender: TObject);
    procedure rbBFClick(Sender: TObject);
    procedure rbCastClick(Sender: TObject);
    procedure rbIdeaClick(Sender: TObject);
    procedure AS_PrimeGenerator1TryRandomPrime(Sender: TObject;
      prime: GiantInt);
//  procedure rbRSAClick(Sender: TObject);
    procedure btGenSymKeyClick(Sender: TObject);
    procedure btLoadSymKeyClick(Sender: TObject);
    procedure btSaveSymKeyClick(Sender: TObject);
    procedure AS_PrimeGenerator1AfterGenPrime(Sender: TObject;
      prime: GiantInt);
    procedure RSA1ChangeKeyD(Sender: TObject);
    procedure RSA1ChangeKeyE(Sender: TObject);
    procedure RSA1ChangeKeyN(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure rbMD2Click(Sender: TObject);
    procedure rbMD4Click(Sender: TObject);
    procedure rbMD5Click(Sender: TObject);
    procedure rbSHA1Click(Sender: TObject);
    procedure btDigestClick(Sender: TObject);
    procedure rbDgDataHexClick(Sender: TObject);
    procedure rbDgDataStrClick(Sender: TObject);
    procedure AfterCalcDigest(Sender: TObject);
    procedure BeforeCalcDigest(Sender: TObject);
    procedure tbEncryptSymFileClick(Sender: TObject);
    procedure tbDecryptSymFileClick(Sender: TObject);
    procedure tbDigestFileClick(Sender: TObject);
    procedure RSA1AfterSign(Sender: TObject; Data: Pointer;
      DataSize: Cardinal);
    procedure RSA1AfterVerify(Sender: TObject; Data: Pointer;
      DataSize: Cardinal; SignData: Pointer; SignSize: Cardinal);
    procedure RSA1BeforeSign(Sender: TObject; Data: Pointer;
      DataSize: Cardinal);
    procedure RSA1BeforeVerify(Sender: TObject; Data: Pointer;
      DataSize: Cardinal; SignData: Pointer; SignSize: Cardinal);
    procedure rbRipEmdClick(Sender: TObject);
    procedure tbEncodeFileClick(Sender: TObject);
    procedure btEncodeClick(Sender: TObject);
    procedure btDecodeClick(Sender: TObject);
    procedure Base641AfterDecode(Sender: TObject);
    procedure Base641AfterEncode(Sender: TObject);
    procedure Base641BeforeDecode(Sender: TObject);
    procedure Base641BeforeEncode(Sender: TObject);
    procedure tbDecodeFileClick(Sender: TObject);
    procedure btUpdRsaKeyClick(Sender: TObject);
    procedure btGenRsaKeyClick(Sender: TObject);
    procedure btLoadRsaKeyClick(Sender: TObject);
    procedure btSaveRsaKeyClick(Sender: TObject);
    procedure rbOaepClick(Sender: TObject);
    procedure rbPkcsClick(Sender: TObject);
    procedure btEncryptRsaClick(Sender: TObject);
    procedure btDecryptRsaClick(Sender: TObject);
    procedure tbSignFileClick(Sender: TObject);
    procedure tbVerifyFileClick(Sender: TObject);
    procedure tbTestRsaKeyClick(Sender: TObject);
    procedure tbEncryptRsaFileClick(Sender: TObject);
    procedure tbDecryptRsaFileClick(Sender: TObject);
    procedure rbRsaDataHexClick(Sender: TObject);
    procedure rbRsaDataStrClick(Sender: TObject);
    procedure rbIVHexClick(Sender: TObject);
    procedure rbIVStrClick(Sender: TObject);
    procedure cbRsaDigestClick(Sender: TObject);
    procedure AS_RandomGenerator1AfterGenRandom(Sender: TObject;  rnd: GiantInt);
    procedure rbSaferClick(Sender: TObject);
    procedure cbUseSaferSKClick(Sender: TObject);
    procedure rbSkipJackClick(Sender: TObject);
  private
    FSelCrypto: TAS_SymmCryptography;
    FTempData: array of Byte;
    FStartMoment: TDateTime;
    procedure SetStatus(Index: Integer; const Value: string);
    procedure RefreshSymKey;
    procedure RefreshRsaKey;
    function  HexStrToBuffer(const S: string; var blen: DWord): Pointer;
  public
    property  Status[Index: Integer]: string write SetStatus;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  rbDESClick(nil);
  rbECBClick(nil);
  rbSymKeyHexClick(nil);
  rbPkcsClick(nil);
  cbSmallPub.ItemIndex := 0;
  cbUseSaferSK.Checked := Safer1.UseSaferSK;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FTempData := nil;
end;

procedure TForm1.SetStatus(Index: Integer; const Value: string);
begin
  StatusBar1.Panels[Index].Text := Value;
end;

function TForm1.HexStrToBuffer(const S: string; var blen: DWord): Pointer;
begin
  blen := HexStrNeedBytes(S);
  SetLength(FTempData, blen);
  HexStrToBytes(S, @FTempData[0], False);
  Result := @FTempData[0];
end;

// editing keys

procedure TForm1.RefreshSymKey;
begin
  if rbSymKeyHex.Checked then rbSymKeyHexClick(nil) else rbSymKeyStrClick(nil);
  if rbIVHex.Checked     then rbIVHexClick(nil)     else rbIVStrClick(nil);
end;

procedure TForm1.RefreshRsaKey;
begin
  MemoRsaKeyN.Lines.Clear; HexStrToLines(Rsa1.KeyNHexStr, MemoRsaKeyN.Lines, 16, ' ');
  MemoRsaKeyD.Lines.Clear; HexStrToLines(Rsa1.KeyDHexStr, MemoRsaKeyD.Lines, 16, ' ');
  MemoRsaKeyE.Lines.Clear; HexStrToLines(Rsa1.KeyEHexStr, MemoRsaKeyE.Lines, 16, ' ');
end;

procedure TForm1.btUpdSymKeyClick(Sender: TObject);
begin
  try
    if rbDES.Checked then begin
      if EditSymKeyOpt.Text <> '' then DES1.CipherMask    := StrToInt(EditSymKeyOpt.Text);
    end else
    if rbRC2.Checked then begin
      if EditSymKeyOpt.Text <> '' then RC21.EffectiveBits := StrToInt(EditSymKeyOpt.Text); end
    else
    if rbRC5.Checked then begin
      if EditSymKeyOpt.Text <> '' then RC51.NumRounds     := StrToInt(EditSymKeyOpt.Text);
    end;

    if rbSymKeyHex.Checked then
      TAS_SymmCryptography(FSelCrypto).KeyHexStr        := EditSymKey.Text else
      TAS_SymmCryptography(FSelCrypto).KeyText          := EditSymKey.Text;

    if rbIVHex.Checked then
      TAS_SymmCryptography(FSelCrypto).InitVectorHexStr := EditIV.Text else
      TAS_SymmCryptography(FSelCrypto).InitVectorText   := EditIV.Text;

  except
    on E: Exception do begin Status[0] := E.Message; Exit; end;
  end;
  Status[0] := '';
end;

procedure TForm1.btUpdRsaKeyClick(Sender: TObject);
begin
  try
    Rsa1.KeyNHexStr := LinesToHexStr(MemoRsaKeyN.Lines);
    Rsa1.KeyDHexStr := LinesToHexStr(MemoRsaKeyD.Lines);
    Rsa1.KeyEHexStr := LinesToHexStr(MemoRsaKeyE.Lines);
  except
    on E: Exception do begin Status[0] := E.Message; Exit; end;
  end;
end;

procedure TForm1.btGenSymKeyClick(Sender: TObject);
begin
  try
    FSelCrypto.GenerateKeys(StrToInt(EditSymKeyLen.Text));
    EditSymKeyLen.Text := IntToStr(FSelCrypto.KeyNumBits div 8);
    RefreshSymKey;
  except
    on E: Exception do begin Status[0] := E.Message; Exit; end;
  end;
end;

procedure TForm1.btGenRsaKeyClick(Sender: TObject);
begin
  try
    RSA1.SmallPublicExp := StrToInt('$'+cbSmallPub.Text);
  except
    RSA1.SmallPublicExp := 0;
    cbSmallPub.Text := '0';
  end;
  try
    Screen.Cursor := crHourGlass;
    FStartMoment := Now;
    RSA1.GenerateKeys(StrToInt(EditRsaKeyLen.Text));
    EditRsaKeyLen.Text := IntToStr(RSA1.KeyNumBits div 8);
    RefreshRsaKey;
    Screen.Cursor := crDefault;
  except
    on E: Exception do begin Status[0] := E.Message; Exit; end;
  end;
  Status[0] := Format('Generating RSA key done.  (%f sec elapsed)', [(Now - FStartMoment) * 24 * 3600]);
  btUpdRsaKeyClick(nil);
end;

procedure TForm1.btLoadSymKeyClick(Sender: TObject);
var s, sext: string;
begin
  try
    OpenDialog1.FileName := '';
    s := Copy(FSelCrypto.Name, 1, Length(FSelCrypto.Name)-1);
    sext := 'key' + Lowercase(Copy(s, 1, 3));
    OpenDialog1.DefaultExt := sext;
    OpenDialog1.Filter := Format('%s keys (*.%s)|*.%1:s', [s, sext]);
    if OpenDialog1.Execute then begin
      FSelCrypto.LoadKeysFromFile(OpenDialog1.FileName);
      RefreshSymKey;
      rbSymKeyHex.Checked := True;
    end;
  except
    on E: Exception do begin Status[0] := E.Message; Exit; end;
  end;
end;

procedure TForm1.btLoadRsaKeyClick(Sender: TObject);
begin
  try
    OpenDialog1.FileName := '';
    OpenDialog1.DefaultExt := 'keyrsa';
    OpenDialog1.Filter := 'RSA keys (*.keyrsa)|*.keyrsa';
    if OpenDialog1.Execute then begin
      RSA1.LoadKeysFromFile(OpenDialog1.FileName);
      RefreshRsaKey;
    end;
  except
    on E: Exception do begin Status[0] := E.Message; Exit; end;
  end;
  Status[0] := '';
end;

procedure TForm1.btSaveSymKeyClick(Sender: TObject);
var s, sext: string;
begin
  try
    OpenDialog1.FileName := '';
    s := Copy(FSelCrypto.Name, 1, Length(FSelCrypto.Name)-1);
    sext := 'key' + Lowercase(Copy(s, 1, 3));
    OpenDialog1.DefaultExt := sext;
    OpenDialog1.Filter := Format('%s keys (*.%s)|*.%1:s', [s, sext]);
    if OpenDialog1.Execute then FSelCrypto.SaveKeysToFile(OpenDialog1.FileName);
  except
    on E: Exception do begin Status[0] := E.Message; Exit; end;
  end;
  Status[0] := '';
end;

procedure TForm1.btSaveRsaKeyClick(Sender: TObject);
begin
  try
    OpenDialog1.FileName := '';
    OpenDialog1.DefaultExt := 'keyrsa';
    OpenDialog1.Filter := 'RSA keys (*.keyrsa)|*.keyrsa';
    if OpenDialog1.Execute then RSA1.SaveKeysToFile(OpenDialog1.FileName);
  except
    on E: Exception do begin Status[0] := E.Message; Exit; end;
  end;
  Status[0] := '';
end;

procedure TForm1.rbSymKeyHexClick(Sender: TObject);
begin
  EditSymKey.Text := TAS_SymmCryptography(FSelCrypto).KeyHexStr;
end;

procedure TForm1.rbSymKeyStrClick(Sender: TObject);
begin
  EditSymKey.Text := TAS_SymmCryptography(FSelCrypto).KeyText;
end;

procedure TForm1.rbIVHexClick(Sender: TObject);
begin
  EditIV.Text := TAS_SymmCryptography(FSelCrypto).InitVectorHexStr;
  EditIV.MaxLength := 16;
end;

procedure TForm1.rbIVStrClick(Sender: TObject);
begin
  EditIV.Text := TAS_SymmCryptography(FSelCrypto).InitVectorText;
  EditIV.MaxLength := 8;
end;

// algorithm

procedure TForm1.rbDESClick(Sender: TObject);
begin
  FSelCrypto := DES1;
  RefreshSymKey;

  LabelSymKeyLim.Caption := '8..256 bytes, multiple of 8';
  EditSymKeyLen.Text     := '24';
  EditSymKeyLen.Enabled  := True;

  PanelSymKeyOpt.Visible := True;
  LabelSymKeyOpt.Caption := 'Cipher mask';
  EditSymKeyOpt.Text     := IntToStr(DES1.CipherMask);
  cbUseSaferSK.Visible   := False;
end;

procedure TForm1.rbRC2Click(Sender: TObject);
begin
  FSelCrypto := RC21;
  RefreshSymKey;

  LabelSymKeyLim.Caption := '1..128 bytes';
  EditSymKeyLen.Text     := '16';
  EditSymKeyLen.Enabled  := True;

  PanelSymKeyOpt.Visible := True;
  LabelSymKeyOpt.Caption := 'Effective bits';
  EditSymKeyOpt.Text     := IntToStr(RC21.EffectiveBits);
  cbUseSaferSK.Visible   := False;
end;

procedure TForm1.rbRC4Click(Sender: TObject);
begin
  FSelCrypto := RC41;
  RefreshSymKey;

  LabelSymKeyLim.Caption := '1 or more bytes';
  EditSymKeyLen.Text     := '16';
  EditSymKeyLen.Enabled  := True;

  PanelSymKeyOpt.Visible := False;
  cbUseSaferSK.Visible   := False;
end;

procedure TForm1.rbRC5Click(Sender: TObject);
begin
  FSelCrypto := RC51;
  RefreshSymKey;

  LabelSymKeyLim.Caption := 'Up to 256 bytes';
  EditSymKeyLen.Text     := '16';
  EditSymKeyLen.Enabled  := True;

  PanelSymKeyOpt.Visible := True;
  LabelSymKeyOpt.Caption := 'Number of rounds';
  EditSymKeyOpt.Text     := IntToStr(RC51.NumRounds);
  cbUseSaferSK.Visible   := False;
end;

procedure TForm1.rbBFClick(Sender: TObject);
begin
  FSelCrypto := BlowFish1;
  RefreshSymKey;

  LabelSymKeyLim.Caption := 'Up to 72 bytes';
  EditSymKeyLen.Text     := '16';
  EditSymKeyLen.Enabled  := True;

  PanelSymKeyOpt.Visible := False;
  cbUseSaferSK.Visible   := False;
end;

procedure TForm1.rbCastClick(Sender: TObject);
begin
  FSelCrypto := Cast1;
  RefreshSymKey;

  LabelSymKeyLim.Caption := 'Up to 16 bytes';
  EditSymKeyLen.Text     := '16';
  EditSymKeyLen.Enabled  := False;
  PanelSymKeyOpt.Visible := False;
  cbUseSaferSK.Visible   := False;
end;

procedure TForm1.rbIdeaClick(Sender: TObject);
begin
  FSelCrypto := Idea1;
  RefreshSymKey;

  LabelSymKeyLim.Caption := '16 bytes';
  EditSymKeyLen.Text     := '16';
  EditSymKeyLen.Enabled  := False;
  PanelSymKeyOpt.Visible := False;
  cbUseSaferSK.Visible   := False;
end;

procedure TForm1.rbSaferClick(Sender: TObject);
begin
  FSelCrypto := Safer1;
  RefreshSymKey;

  LabelSymKeyLim.Caption := '16 bytes';
  EditSymKeyLen.Text     := '16';
  EditSymKeyLen.Enabled  := False;

  PanelSymKeyOpt.Visible := True;
  LabelSymKeyOpt.Caption := 'Number of rounds';
  EditSymKeyOpt.Text     := IntToStr(Safer1.NumRounds);
  cbUseSaferSK.Visible   := True;
end;

procedure TForm1.rbSkipJackClick(Sender: TObject);
begin
  FSelCrypto := SkipJack1;
  RefreshSymKey;

  LabelSymKeyLim.Caption := '10 bytes';
  EditSymKeyLen.Text     := '10';
  EditSymKeyLen.Enabled  := False;

  PanelSymKeyOpt.Visible := False;
  cbUseSaferSK.Visible   := False;
end;

procedure TForm1.cbUseSaferSKClick(Sender: TObject);
begin
  Safer1.UseSaferSK := cbUseSaferSK.Checked;
end;

procedure TForm1.rbPkcsClick(Sender: TObject);
begin
  LabelRsaKeyLim.Caption   := '32 to 512 bytes';
  EditRsaKeyLen.Text       := '32';
  RSA1.EncryptionScheme    := esPkcs1;
  PanelShemeDigest.Visible := False;
end;

procedure TForm1.rbOaepClick(Sender: TObject);
begin
  LabelRsaKeyLim.Caption   := '64 to 512 bytes';
  EditRsaKeyLen.Text       := '64';
  RSA1.EncryptionScheme    := esOaep;

  PanelShemeDigest.Visible := True;

  if RSA1.EncryptingDigest = MDXforRSA  then cbRsaDigest.ItemIndex  := Ord(MDXforRSA.Version) else
  if RSA1.EncryptingDigest = SHA1forRSA then cbRsaDigest.ItemIndex  := Ord(dgMD5)+1           else
    cbRsaDigest.ItemIndex  := Ord(dgMD5)+2;

  MemoRSA2.Clear;
  MemoRSA3.Clear;
end;

procedure TForm1.cbRsaDigestClick(Sender: TObject);
begin
  case cbRsaDigest.ItemIndex of
    Ord(dgMD2)..Ord(dgMD5): RSA1.EncryptingDigest := MDXforRSA;
    Ord(dgMD5)+1:           RSA1.EncryptingDigest := SHA1forRSA;
    Ord(dgMD5)+2:           RSA1.EncryptingDigest := RIPEMDforRSA;
  end;
  MemoRSA2.Clear;
  MemoRSA3.Clear;
end;

// cipher mode

procedure TForm1.rbECBClick(Sender: TObject);
begin
  TAS_SymmCryptography(FSelCrypto).CipherMode := cmECB;
  PanelIV.Visible := False;
end;

procedure TForm1.rbCBCClick(Sender: TObject);
begin
  TAS_SymmCryptography(FSelCrypto).CipherMode := cmCBC;
  PanelIV.Visible := True;
end;

procedure TForm1.rbCFBClick(Sender: TObject);
begin
  TAS_SymmCryptography(FSelCrypto).CipherMode := cmCFB;
  PanelIV.Visible := True;
end;

procedure TForm1.rbOFBClick(Sender: TObject);
begin
  TAS_SymmCryptography(FSelCrypto).CipherMode := cmOFB;
  PanelIV.Visible := True;
end;

// data

procedure TForm1.rbSymDataHexClick(Sender: TObject);
begin
  EditSym1.Text := StrToHexStr(EditSym1.Text, False);
  EditSym3.Text := StrToHexStr(EditSym3.Text, False);
end;

procedure TForm1.rbSymDataStrClick(Sender: TObject);
begin
  EditSym1.Text := HexStrToStr(EditSym1.Text, False);
  EditSym3.Text := HexStrToStr(EditSym3.Text, False);
end;

procedure TForm1.rbRsaDataHexClick(Sender: TObject);
var i: Integer;
begin
  for i := 0 to MemoRsa1.Lines.Count-1 do MemoRsa1.Lines[i] := StrToHexStr(MemoRsa1.Lines[i], False);
  for i := 0 to MemoRsa3.Lines.Count-1 do MemoRsa3.Lines[i] := StrToHexStr(MemoRsa3.Lines[i], False);
//EditRsa1.Text := StrToHexStr(EditRsa1.Text, False);
//EditRsa3.Text := StrToHexStr(EditRsa3.Text, False);
end;

procedure TForm1.rbRsaDataStrClick(Sender: TObject);
var i: Integer;
begin
  for i := 0 to MemoRsa1.Lines.Count-1 do MemoRsa1.Lines[i] := HexStrToStr(MemoRsa1.Lines[i], False);
  for i := 0 to MemoRsa3.Lines.Count-1 do MemoRsa3.Lines[i] := HexStrToStr(MemoRsa3.Lines[i], False);
//EditRsa1.Text := HexStrToStr(EditRsa1.Text, False);
//EditRsa3.Text := HexStrToStr(EditRsa3.Text, False);
end;

// encrypt/decrypt

procedure TForm1.btEncryptSymClick(Sender: TObject);
var S: string; P: Pointer; len: DWord;
begin
  btUpdSymKeyClick(nil);

  if rbSymDataHex.Checked then
    P := HexStrToBuffer(EditSym1.Text, len)
  else begin
    S := EditSym1.Text;
    P := @S[1];
    len := Length(S);
  end;

  try
    FSelCrypto.Encrypt(P, len);
  except
    on E: Exception do begin Status[0] := E.Message; Exit; end;
  end;

  if not FSelCrypto.CipherInPlace then begin
    P := FSelCrypto.EncryptedData.Memory;
    len := FSelCrypto.EncryptedData.Size;
  end;
  EditSym2.Text := BytesToHexStr(P, len, False);

  btDecryptSymClick(nil);
end;

procedure TForm1.btDecryptSymClick(Sender: TObject);
var P: Pointer; len: DWord;
begin
  P := HexStrToBuffer(EditSym2.Text, len);
  try
    FSelCrypto.Decrypt(P, len);
  except
    on E: Exception do begin Status[0] := E.Message; Exit; end;
  end;
  if not FSelCrypto.CipherInPlace then begin
    P := FSelCrypto.DecryptedData.Memory;
    len := FSelCrypto.DecryptedData.Size;
  end;
  if rbSymDataHex.Checked then
    EditSym3.Text := BytesToHexStr(P, len, False) else
    EditSym3.Text := BytesToStr(P, len, False);
end;

procedure TForm1.btEncryptRsaClick(Sender: TObject);
var S: string; P: Pointer; len: DWord;
begin
  btUpdRsaKeyClick(nil);  // save key if changed
  RSA1.SeedHexStr := LinesToHexStr(MemoOaepSeed.Lines);

  if rbRsaDataHex.Checked then begin
    S := LinesToHexStr(MemoRsa1.Lines);
    P := HexStrToBuffer(S, len);
  end
  else begin
    S := MemoRsa1.Lines.Text;
    P := @S[1];
    len := Length(S);
  end;

  try
    RSA1.Encrypt(P, len);
  except
    on E: Exception do begin Status[0] := E.Message; Exit; end;
  end;

  S := BytesToHexStr(RSA1.EncryptedData.Memory, RSA1.EncryptedData.Size, False);

  MemoRsa2.Lines.Clear;
  HexStrToLines(S, MemoRsa2.Lines, 16, ' ');

  MemoOaepSeed.Lines.Clear;
  HexStrToLines(Rsa1.SeedHexStr, MemoOaepSeed.Lines, 16, ' ');

  btDecryptRsaClick(nil);
end;

procedure TForm1.btDecryptRsaClick(Sender: TObject);
var P: Pointer; S: string; len: DWord;
begin
  S := LinesToHexStr(MemoRsa2.Lines);
  P := HexStrToBuffer(S, len);
  try
    RSA1.Decrypt(P, len);
  except
    on E: Exception do begin Status[0] := E.Message; Exit; end;
  end;

  if rbRsaDataHex.Checked then begin
    S := BytesToHexStr(RSA1.DecryptedData.Memory, RSA1.DecryptedData.Size, False);
    HexStrToLines(S, MemoRsa3.Lines, 16, ' ');
  end
  else begin
    SetLength(S, RSA1.DecryptedData.Size);
    Move(RSA1.DecryptedData.Memory^, S[1], Length(S));
    MemoRsa3.Lines.Text := S;
  end;
end;

procedure TForm1.tbEncryptSymFileClick(Sender: TObject);
var s, sext, senc: string;
begin
  try
    Screen.Cursor := crHourGlass;
    try
      OpenDialog1.FileName := '';
      OpenDialog1.Filter := 'All files (*.*)|*.*';
      if OpenDialog1.Execute then begin
        s := Copy(FSelCrypto.Name, 1, Length(FSelCrypto.Name)-1);
        sext := Lowercase(Copy(s, 1, 3));
        senc := ChangeFileExt(OpenDialog1.FileName, '.'+sext);
        Status[0] := 'Encrypting file: ' + OpenDialog1.FileName + '...';
        FSelCrypto.EncryptFile(OpenDialog1.FileName, senc);
        MessageDlg('Encrypted file is: ' + senc, mtConfirmation, [mbOK], 0);
      end;
    finally
      Screen.Cursor := crDefault;
    end;
  except
    on E: Exception do begin Status[0] := E.Message; Exit; end;
  end;
  Status[0] := '';
end;

procedure TForm1.tbDecryptSymFileClick(Sender: TObject);
var s, sext, sdec: string;
begin
  try
    Screen.Cursor := crHourGlass;
    try
      OpenDialog1.FileName := '';
      OpenDialog1.Filter := 'All files (*.*)|*.*';
      s := Copy(FSelCrypto.Name, 1, Length(FSelCrypto.Name)-1);
      sext := Lowercase(Copy(s, 1, 3));
      OpenDialog1.DefaultExt := sext;
      OpenDialog1.Filter := Format('%s encrypted files (*.%s)|*.%1:s|All files (*.*)|*.*', [s, sext]);
      if OpenDialog1.Execute then begin
        sdec := ChangeFileExt(OpenDialog1.FileName, '.tmp');
        Status[0] := 'Decrypting file: ' + OpenDialog1.FileName + '...';
        FSelCrypto.DecryptFile(OpenDialog1.FileName, sdec);
        MessageDlg('Decrypted file is: ' + sdec, mtConfirmation, [mbOK], 0);
      end;
    finally
      Screen.Cursor := crDefault;
    end;
  except
    on E: Exception do begin Status[0] := E.Message; Exit; end;
  end;
  Status[0] := '';
end;

procedure TForm1.tbEncryptRsaFileClick(Sender: TObject);
var senc: string;
begin
  try
    Screen.Cursor := crHourGlass;
    try
      OpenDialog1.FileName := '';
      OpenDialog1.Filter := 'All files (*.*)|*.*';
      if OpenDialog1.Execute then begin
        senc := ChangeFileExt(OpenDialog1.FileName, '.rsa');
        Status[0] := 'Encrypting file: ' + OpenDialog1.FileName + '...';
        RSA1.EncryptFile(OpenDialog1.FileName, senc);
        MessageDlg('Encrypted file is: ' + senc, mtConfirmation, [mbOK], 0);
      end;
    finally
      Screen.Cursor := crDefault;
    end;
  except
    on E: Exception do begin Status[0] := E.Message; Exit; end;
  end;
  Status[0] := '';
end;

procedure TForm1.tbDecryptRsaFileClick(Sender: TObject);
var sdec: string;
begin
  try
    Screen.Cursor := crHourGlass;
    try
      OpenDialog1.FileName := '';
      OpenDialog1.DefaultExt := 'rsa';
      OpenDialog1.Filter := 'RSA encrypted files (*.rsa)|*.rsa|All files (*.*)|*.*';
      if OpenDialog1.Execute then begin
        sdec := ChangeFileExt(OpenDialog1.FileName, '.tmp');
        Status[0] := 'Decrypting file: ' + OpenDialog1.FileName + '...';
        RSA1.DecryptFile(OpenDialog1.FileName, sdec);
        MessageDlg('Decrypted file is: ' + sdec, mtConfirmation, [mbOK], 0);
      end;
    finally
      Screen.Cursor := crDefault;
    end;
  except
    on E: Exception do begin Status[0] := E.Message; Exit; end;
  end;
  Status[0] := '';
end;

// sign/verify

procedure TForm1.tbSignFileClick(Sender: TObject);
begin
  try
    OpenDialog1.FileName := '';
    OpenDialog1.Filter := 'All files (*.*)|*.*';
    if OpenDialog1.Execute then begin
      RSA1.SignFile(OpenDialog1.FileName);
      RSA1.SaveSignatureToFile(ChangeFileExt(OpenDialog1.FileName, '.sig'));
    end;
  except
    on E: Exception do begin Status[0] := E.Message; Exit; end;
  end;
  Status[0] := '';
end;

procedure TForm1.tbVerifyFileClick(Sender: TObject);
begin
  try
    OpenDialog1.FileName := '';
    OpenDialog1.Filter := 'All files (*.*)|*.*';
    if OpenDialog1.Execute then begin
      RSA1.LoadSignatureFromFile(ChangeFileExt(OpenDialog1.FileName, '.sig'));
      RSA1.VerifyFileSignature(OpenDialog1.FileName, RSA1.Signature.Memory, RSA1.Signature.Size);
      ShowMessage('Signature OK!');
    end;
  except
    on E: Exception do begin Status[0] := E.Message; Exit; end;
  end;
  Status[0] := '';
end;

procedure TForm1.tbTestRsaKeyClick(Sender: TObject);
begin
  if RSA1.TestKeys then
    MessageDlg('RSA keys OK',     mtInformation, [mbOK], 0) else
    MessageDlg('RSA key invalid', mtError,       [mbOK], 0);
end;

// logging

procedure TForm1.tbClearLogClick(Sender: TObject);
begin
  MemoLog.Clear;
end;

procedure TForm1.CryptAfterDecrypt(Sender: TObject);
var s: string;
begin
  s := Copy(TComponent(Sender).Name, 1, Length(TComponent(Sender).Name)-1);
  MemoLog.Lines.Add(s + ': AfterDecrypt');
end;

procedure TForm1.CryptAfterDecryptBlock(Sender: TObject; Block: Pointer; Offset, Size: DWord);
var s: string;
begin
  s := Copy(TComponent(Sender).Name, 1, Length(TComponent(Sender).Name)-1);
  MemoLog.Lines.Add(s + ': AfterDecryptBlock');
  Application.ProcessMessages;
end;

procedure TForm1.CryptAfterEncrypt(Sender: TObject);
var s: string;
begin
  s := Copy(TComponent(Sender).Name, 1, Length(TComponent(Sender).Name)-1);
  MemoLog.Lines.Add(s + ': AfterEncrypt');
end;

procedure TForm1.CryptAfterEncryptBlock(Sender: TObject; Block: Pointer; Offset, Size: DWord);
var s: string;
begin
  s := Copy(TComponent(Sender).Name, 1, Length(TComponent(Sender).Name)-1);
  MemoLog.Lines.Add(s + ': AfterEncryptBlock');
  Application.ProcessMessages;
end;

procedure TForm1.CryptAfterGenKeys(Sender: TObject);
var s: string;
begin
  s := Copy(TComponent(Sender).Name, 1, Length(TComponent(Sender).Name)-1);
  MemoLog.Lines.Add(s + ': AfterGenKeys');
end;

procedure TForm1.CryptAfterLoadKeys(Sender: TObject);
var s: string;
begin
  s := Copy(TComponent(Sender).Name, 1, Length(TComponent(Sender).Name)-1);
  MemoLog.Lines.Add(s + ': AfterLoadKeys');
end;

procedure TForm1.CryptAfterSaveKeys(Sender: TObject);
var s: string;
begin
  s := Copy(TComponent(Sender).Name, 1, Length(TComponent(Sender).Name)-1);
  MemoLog.Lines.Add(s + ': AfterSaveKeys');
end;

procedure TForm1.CryptBeforeDecrypt(Sender: TObject);
var s: string;
begin
  s := Copy(TComponent(Sender).Name, 1, Length(TComponent(Sender).Name)-1);
  MemoLog.Lines.Add(s + ': BeforeDecrypt');
end;

procedure TForm1.CryptBeforeDecryptBlock(Sender: TObject; Block: Pointer; Offset, Size: DWord);
var s: string;
begin
  s := Copy(TComponent(Sender).Name, 1, Length(TComponent(Sender).Name)-1);
  MemoLog.Lines.Add(s + ': BeforeDecryptBlock');
  Application.ProcessMessages;
end;

procedure TForm1.CryptBeforeEncrypt(Sender: TObject);
var s: string;
begin
  s := Copy(TComponent(Sender).Name, 1, Length(TComponent(Sender).Name)-1);
  MemoLog.Lines.Add(s + ': BeforeEncrypt');
end;

procedure TForm1.CryptBeforeEncryptBlock(Sender: TObject; Block: Pointer; Offset, Size: DWord);
var s: string;
begin
  s := Copy(TComponent(Sender).Name, 1, Length(TComponent(Sender).Name)-1);
  MemoLog.Lines.Add(s + ': BeforeEncryptBlock');
  Application.ProcessMessages;
end;

procedure TForm1.CryptBeforeGenKeys(Sender: TObject);
var s: string;
begin
  s := Copy(TComponent(Sender).Name, 1, Length(TComponent(Sender).Name)-1);
  MemoLog.Lines.Add(s + ': BeforeGenKeys');
end;

procedure TForm1.CryptBeforeLoadKeys(Sender: TObject);
var s: string;
begin
  s := Copy(TComponent(Sender).Name, 1, Length(TComponent(Sender).Name)-1);
  MemoLog.Lines.Add(s + ': BeforeLoadKeys');
end;

procedure TForm1.CryptBeforeSaveKeys(Sender: TObject);
var s: string;
begin
  s := Copy(TComponent(Sender).Name, 1, Length(TComponent(Sender).Name)-1);
  MemoLog.Lines.Add(s + ': BeforeSaveKeys');
end;

procedure TForm1.SymmChangeInitVector(Sender: TObject);
var s: string;
begin
  s := Copy(TComponent(Sender).Name, 1, Length(TComponent(Sender).Name)-1);
  MemoLog.Lines.Add(s + ': ChangeInitVector');
end;

procedure TForm1.SymmChangeKey(Sender: TObject);
var s: string;
begin
  s := Copy(TComponent(Sender).Name, 1, Length(TComponent(Sender).Name)-1);
  MemoLog.Lines.Add(s + ': ChangeKey');
end;

procedure TForm1.SymmPostValidateKey(Sender: TObject; Key: Pointer;
  KeyByteLen: Integer; var KeyValid: Boolean);
var s: string;
begin
  s := Copy(TComponent(Sender).Name, 1, Length(TComponent(Sender).Name)-1);
  MemoLog.Lines.Add(s + ': PostValidateKey');
end;

procedure TForm1.AS_PrimeGenerator1TryRandomPrime(Sender: TObject;  prime: GiantInt);
begin
  MemoLog.Lines.Add(Format('Check random is prime: %s', [GiantIntToHex(prime)]));
  Application.ProcessMessages;
end;

procedure TForm1.AS_PrimeGenerator1AfterGenPrime(Sender: TObject; prime: GiantInt);
begin
  MemoLog.Lines.Add(Format('Found prime: %s', [GiantIntToHex(prime)]));
end;

procedure TForm1.RSA1ChangeKeyD(Sender: TObject);
begin
  MemoLog.Lines.Add(Format('RSA: key D changed: %s', [RSA1.KeyDHexStr]));
end;

procedure TForm1.RSA1ChangeKeyE(Sender: TObject);
begin
  MemoLog.Lines.Add(Format('RSA: key E changed: %s', [RSA1.KeyEHexStr]));
end;

procedure TForm1.RSA1ChangeKeyN(Sender: TObject);
begin
  MemoLog.Lines.Add(Format('RSA: key N changed: %s', [RSA1.KeyNHexStr]));
end;

// Digest

procedure TForm1.rbMD2Click(Sender: TObject);
begin
  MDX1.Version := dgMD2;
  EditDigest.Text := '';
end;

procedure TForm1.rbMD4Click(Sender: TObject);
begin
  MDX1.Version := dgMD4;
  EditDigest.Text := '';
end;

procedure TForm1.rbMD5Click(Sender: TObject);
begin
  MDX1.Version := dgMD5;
  EditDigest.Text := '';
end;

procedure TForm1.rbSHA1Click(Sender: TObject);
begin
  EditDigest.Text := '';
end;

procedure TForm1.rbRipEmdClick(Sender: TObject);
begin
  EditDigest.Text := '';
end;

procedure TForm1.btDigestClick(Sender: TObject);
var P: Pointer; len: DWord;
begin
  try
    if rbDgDataHex.Checked then begin
      P := HexStrToBuffer(EditDgData.Text, len);
      if rbSHA1.Checked   then SHA1.CalcDigest(P, len) else
      if rbRipEmd.Checked then Rip1.CalcDigest(P, len) else
        MDX1.CalcDigest(P, len);
    end
    else begin
      if rbSHA1.Checked   then SHA1.CalcDigestOfString(EditDgData.Text) else
      if rbRipEmd.Checked then Rip1.CalcDigestOfString(EditDgData.Text) else
        MDX1.CalcDigestOfString(EditDgData.Text);
    end;
    if rbSHA1.Checked     then EditDigest.Text := BytesToHexStr(SHA1.Digest, SHA1.DigestSize, False) else
    if rbRipEmd.Checked   then EditDigest.Text := BytesToHexStr(Rip1.Digest, Rip1.DigestSize, False) else
      EditDigest.Text := BytesToHexStr(MDX1.Digest, MDX1.DigestSize, False);
  except
    on E: Exception do begin Status[0] := E.Message; Exit; end;
  end;
end;

procedure TForm1.rbDgDataHexClick(Sender: TObject);
begin
  EditDgData.Text := StrToHexStr(EditDgData.Text, False);
end;

procedure TForm1.rbDgDataStrClick(Sender: TObject);
begin
  EditDgData.Text := HexStrToStr(EditDgData.Text, False);
end;

procedure TForm1.tbDigestFileClick(Sender: TObject);
begin
  OpenDialog1.FileName := '';
  OpenDialog1.Filter := 'All files (*.*)|*.*';
  if OpenDialog1.Execute then begin
    if rbSHA1.Checked then begin
      SHA1.CalcDigestOfFile(OpenDialog1.FileName);
      EditDigest.Text := BytesToHexStr(SHA1.Digest, SHA1.DigestSize, False);
    end else
    if rbRipEmd.Checked then begin
      Rip1.CalcDigestOfFile(OpenDialog1.FileName);
      EditDigest.Text := BytesToHexStr(Rip1.Digest, Rip1.DigestSize, False);
    end
    else begin
      MDX1.CalcDigestOfString(OpenDialog1.FileName);
      EditDigest.Text := BytesToHexStr(MDX1.Digest, MDX1.DigestSize, False);
    end;
  end;
end;

// encoding /decoding

procedure TForm1.tbEncodeFileClick(Sender: TObject);
begin
  try
    OpenDialog1.FileName := '';
    OpenDialog1.Filter := 'All files (*.*)|*.*';
    if OpenDialog1.Execute then begin
      if rbBase64.Checked then begin
        Base641.EncodeFile(OpenDialog1.FileName, ChangeFileExt(OpenDialog1.FileName, '.b64'));
      end;
    end;
  except
    on E: Exception do begin Status[0] := E.Message; Exit; end;
  end;
end;

procedure TForm1.tbDecodeFileClick(Sender: TObject);
begin
  try
    OpenDialog1.FileName := '';
    OpenDialog1.Filter := 'All files (*.*)|*.*';
    if OpenDialog1.Execute then begin
      if rbBase64.Checked then begin
        Base641.DecodeFile(OpenDialog1.FileName, ChangeFileExt(OpenDialog1.FileName, '.tmp'));
      end;
    end;
  except
    on E: Exception do begin Status[0] := E.Message; Exit; end;
  end;
end;

procedure TForm1.btEncodeClick(Sender: TObject);
begin
  try
    if rbBase64.Checked then begin
      EditEncoded.Text := Base641.EncodeString(EditCodeSource.Text);
      EditDecoded.Text := Base641.DecodeString(EditEncoded.Text);
    end;
  except
    on E: Exception do begin Status[0] := E.Message; Exit; end;
  end;
end;

procedure TForm1.btDecodeClick(Sender: TObject);
begin
  try
    if rbBase64.Checked then begin
      EditDecoded.Text := Base641.DecodeString(EditEncoded.Text);
    end;
  except
    on E: Exception do begin Status[0] := E.Message; Exit; end;
  end;
end;

// logging

procedure TForm1.AfterCalcDigest(Sender: TObject);
var s: string;
begin
  s := Copy(TComponent(Sender).Name, 1, Length(TComponent(Sender).Name)-1);
  MemoLog.Lines.Add(s + ': AfterCalcDigest');
end;

procedure TForm1.BeforeCalcDigest(Sender: TObject);
var s: string;
begin
  s := Copy(TComponent(Sender).Name, 1, Length(TComponent(Sender).Name)-1);
  MemoLog.Lines.Add(s + ': BeforeCalcDigest');
end;

procedure TForm1.RSA1AfterSign(Sender: TObject; Data: Pointer; DataSize: Cardinal);
var s: string;
begin
  s := Copy(TComponent(Sender).Name, 1, Length(TComponent(Sender).Name)-1);
  MemoLog.Lines.Add(s + ': AfterSign');
end;

procedure TForm1.RSA1AfterVerify(Sender: TObject; Data: Pointer;
  DataSize: Cardinal; SignData: Pointer; SignSize: Cardinal);
var s: string;
begin
  s := Copy(TComponent(Sender).Name, 1, Length(TComponent(Sender).Name)-1);
  MemoLog.Lines.Add(s + ': AfterVerify');
end;

procedure TForm1.RSA1BeforeSign(Sender: TObject; Data: Pointer; DataSize: Cardinal);
var s: string;
begin
  s := Copy(TComponent(Sender).Name, 1, Length(TComponent(Sender).Name)-1);
  MemoLog.Lines.Add(s + ': beforeSign');
end;

procedure TForm1.RSA1BeforeVerify(Sender: TObject; Data: Pointer;
  DataSize: Cardinal; SignData: Pointer; SignSize: Cardinal);
var s: string;
begin
  s := Copy(TComponent(Sender).Name, 1, Length(TComponent(Sender).Name)-1);
  MemoLog.Lines.Add(s + ': BeforeVerify');
end;

procedure TForm1.Base641AfterDecode(Sender: TObject);
var s: string;
begin
  s := Copy(TComponent(Sender).Name, 1, Length(TComponent(Sender).Name)-1);
  MemoLog.Lines.Add(s + ': AfterDecode');
end;

procedure TForm1.Base641AfterEncode(Sender: TObject);
var s: string;
begin
  s := Copy(TComponent(Sender).Name, 1, Length(TComponent(Sender).Name)-1);
  MemoLog.Lines.Add(s + ': AfterEncode');
end;

procedure TForm1.Base641BeforeDecode(Sender: TObject);
var s: string;
begin
  s := Copy(TComponent(Sender).Name, 1, Length(TComponent(Sender).Name)-1);
  MemoLog.Lines.Add(s + ': BeforeDecode');
end;

procedure TForm1.Base641BeforeEncode(Sender: TObject);
var s: string;
begin
  s := Copy(TComponent(Sender).Name, 1, Length(TComponent(Sender).Name)-1);
  MemoLog.Lines.Add(s + ': BeforeEncode');
end;

procedure TForm1.AS_RandomGenerator1AfterGenRandom(Sender: TObject; rnd: GiantInt);
begin
  Status[0] := Format('Generating RSA key...  (%f sec elapsed)', [(Now - FStartMoment) * 24 * 3600]);
end;

end.
